#  JOIN COUNTS FROM MULTIPLE FILES (JOINCOUNTFILES)

##############################################################
# MIT License

# Copyright (c) [2020] [ZACHARY L. DWIGHT]

# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:

# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
##############################################################
#
#
# Use for merging comma delimited files of sums or totals
# First column is unique ID or name or label
# Second column is number

# Example...
# Sem1-Points.txt
# Jack, 56
# Jill, 100

# Sem2-Points.txt
# Jack, 80
# Jill, 99

# puts JOINCOUNTFILES::MergeCounts.buildfile('Sem1-Points.txt','Sem2-Points.txt','asc','MergedFile.txt')

# MergedFile.txt
# Jack, 136
# Jill, 199

module JOINCOUNTFILES
class MergeCounts
	def self.buildfile(majorFile,minorFile,sort,outputfile)
	
		mers1 = Hash.new()
		mers2 = Hash.new()
		comboHash = Hash.new()
		
		 File.foreach(majorFile) {|x| 
			xarr = x.split(",")
			mers1.store(xarr[0],xarr[1].to_i)
			}
		
		 File.foreach(minorFile) {|y| 
			yarr = y.split(",")
			mers2.store(yarr[0],yarr[1].to_i)
			}
			
		comboHash = mers1.merge(mers2){|key, oldval, newval| newval + oldval}
		
		if(sort == 'asc')
		open(outputfile, 'w') { |f|
			comboHash.sort{|a,b| a[1]<=>b[1]}.each { |elem|
			f.puts "#{elem[0]},#{elem[1]}"
				}
			}
		end
		if(sort == 'desc')
		open(outputfile, 'w') { |f|
			comboHash.sort{|a,b| b[1]<=>a[1]}.each { |elem|
			f.puts "#{elem[0]},#{elem[1]}"
				}
			}
		end
	return 0
	end

end
end

